Index: src/mlx/gui/pirep.py
===================================================================
--- src/mlx/gui/pirep.py	(revision 437)
+++ src/mlx/gui/pirep.py	(revision 831)
@@ -29,5 +29,5 @@
         The frame will contain an alignment to properly distance the
         insides. The alignment will contain a VBox to contain the real
-        contents. 
+        contents.
 
         The function returns a tuple with the following items:
@@ -43,5 +43,5 @@
         box = gtk.VBox()
         alignment.add(box)
-        
+
         return (frame, box)
 
@@ -66,5 +66,5 @@
     def getTextWindow(heightRequest = 40):
         """Get a scrollable text window.
-        
+
         Returns a tuple of the following items:
         - the window,
@@ -87,6 +87,6 @@
                     dataLabelXAlignment = 0.0):
         """Attach a labeled data to the given column and row of the
-        table. 
-        
+        table.
+
         If width is given, that will be the width of the data
         label.
@@ -95,5 +95,5 @@
         dataBox = gtk.HBox()
         table.attach(dataBox, column, column+1, row, row+1)
-        
+
         dataLabel = PIREPViewer.addLabeledData(dataBox, labelText,
                                                width = width)
@@ -105,9 +105,9 @@
     def addLabeledData(hBox, labelText, width = None, dataPadding = 8):
         """Add a label and a data label to the given HBox.
-        
+
         Returnsd the data label."""
         label = PIREPViewer.getLabel(labelText)
         hBox.pack_start(label, False, False, 0)
-                
+
         dataLabel = PIREPViewer.getDataLabel(width = width)
         hBox.pack_start(dataLabel, False, False, dataPadding)
@@ -122,5 +122,5 @@
         filler.set_size_request(-1, height)
         vBox.pack_start(filler, False, False, 0)
-        
+
     @staticmethod
     def timestamp2text(label, timestamp):
@@ -136,14 +136,14 @@
                                           xstr("pirepView_title"),
                                           parent = gui.mainWindow)
-                                          
+
         self.set_resizable(False)
 
         self._gui = gui
-        
+
         contentArea = self.get_content_area()
 
         self._notebook = gtk.Notebook()
         contentArea.pack_start(self._notebook, False, False, 4)
-        
+
         dataTab = self._buildDataTab()
         label = gtk.Label(xstr("pirepView_tab_data"))
@@ -151,5 +151,5 @@
         label.set_tooltip_text(xstr("pirepView_tab_data_tooltip"))
         self._notebook.append_page(dataTab, label)
-        
+
         commentsTab = self._buildCommentsTab()
         label = gtk.Label(xstr("pirepView_tab_comments"))
@@ -157,5 +157,5 @@
         label.set_tooltip_text(xstr("pirepView_tab_comments_tooltip"))
         self._notebook.append_page(commentsTab, label)
-        
+
         logTab = self._buildLogTab()
         label = gtk.Label(xstr("pirepView_tab_log"))
@@ -166,5 +166,5 @@
         self._okButton = self.add_button(xstr("button_ok"), RESPONSETYPE_OK)
         self._okButton.set_can_default(True)
-        
+
     def setPIREP(self, pirep):
         """Setup the data in the dialog from the given PIREP."""
@@ -175,5 +175,5 @@
         aircraftType = xstr("aircraft_" + icaoCodes[bookedFlight.aircraftType].lower())
         self._aircraftType.set_text(aircraftType)
-        
+
         self._departureICAO.set_text(bookedFlight.departureICAO)
         self._departureTime.set_text("%02d:%02d" % \
@@ -191,5 +191,5 @@
         self._cargoWeight.set_text(str(bookedFlight.cargoWeight))
         self._mailWeight.set_text(str(bookedFlight.mailWeight))
-        
+
         self._route.get_buffer().set_text(bookedFlight.route)
 
@@ -218,5 +218,5 @@
         PIREPViewer.timestamp2text(self._flightTimeStart, pirep.flightTimeStart)
         PIREPViewer.timestamp2text(self._flightTimeEnd, pirep.flightTimeEnd)
-        
+
         self._flownDistance.set_text("%.1f" % (pirep.flownDistance,))
         self._fuelUsed.set_text("%.0f" % (pirep.fuelUsed,))
@@ -233,5 +233,5 @@
         self._flownCargoWeight.set_text("%.0f" % (pirep.cargoWeight,))
         self._flownMailWeight.set_text("%.0f" % (pirep.mailWeight,))
-        self._flightType.set_text(xstr("flighttype_" + 
+        self._flightType.set_text(xstr("flighttype_" +
                                        flightType2string(pirep.flightType)))
         self._online.set_text(xstr("pirepView_" +
@@ -242,6 +242,6 @@
             if delayCodes: delayCodes += ", "
             delayCodes += code
-        
-        self._delayCodes.get_buffer().set_text(delayCodes)        
+
+        self._delayCodes.get_buffer().set_text(delayCodes)
 
         self._comments.get_buffer().set_text(pirep.comments)
@@ -270,8 +270,8 @@
         box1 = gtk.VBox()
         table.attach(box1, 0, 1, 0, 1)
-        
+
         box2 = gtk.VBox()
         table.attach(box2, 1, 2, 0, 1)
-        
+
         flightFrame = self._buildFlightFrame()
         box1.pack_start(flightFrame, False, False, 4)
@@ -296,10 +296,10 @@
     def _buildFlightFrame(self):
         """Build the frame for the flight data."""
-        
+
         (frame, mainBox) = PIREPViewer.createFrame(xstr("pirepView_frame_flight"))
-        
+
         dataBox = gtk.HBox()
         mainBox.pack_start(dataBox, False, False, 0)
-        
+
         self._callsign = \
             PIREPViewer.addLabeledData(dataBox,
@@ -327,5 +327,5 @@
         mainBox.pack_start(table, False, False, 0)
         table.set_row_spacings(4)
-        table.set_col_spacings(8)        
+        table.set_col_spacings(8)
 
         self._departureICAO = \
@@ -352,5 +352,5 @@
         mainBox.pack_start(table, False, False, 0)
         table.set_row_spacings(4)
-        table.set_col_spacings(8)        
+        table.set_col_spacings(8)
 
         self._numPassengers = \
@@ -365,23 +365,23 @@
 
         self._bagWeight = \
-            PIREPViewer.tableAttach(table, 0, 1, 
+            PIREPViewer.tableAttach(table, 0, 1,
                                     xstr("pirepView_bagWeight"),
                                     width = 5)
 
         self._cargoWeight = \
-            PIREPViewer.tableAttach(table, 1, 1, 
+            PIREPViewer.tableAttach(table, 1, 1,
                                     xstr("pirepView_cargoWeight"),
                                     width = 5)
 
         self._mailWeight = \
-            PIREPViewer.tableAttach(table, 2, 1, 
+            PIREPViewer.tableAttach(table, 2, 1,
                                     xstr("pirepView_mailWeight"),
                                     width = 5)
-            
+
         PIREPViewer.addVFiller(mainBox)
 
         mainBox.pack_start(PIREPViewer.getLabel(xstr("pirepView_route")),
                            False, False, 0)
-        
+
         (routeWindow, self._route) = PIREPViewer.getTextWindow()
         mainBox.pack_start(routeWindow, False, False, 0)
@@ -392,12 +392,12 @@
         """Build the frame for the user-specified route and flight
         level."""
-        
+
         (frame, mainBox) = PIREPViewer.createFrame(xstr("pirepView_frame_route"))
 
         levelBox = gtk.HBox()
         mainBox.pack_start(levelBox, False, False, 0)
-        
+
         self._filedCruiseLevel = \
-            PIREPViewer.addLabeledData(levelBox, 
+            PIREPViewer.addLabeledData(levelBox,
                                        xstr("pirepView_filedCruiseLevel"),
                                        width = 6)
@@ -416,5 +416,5 @@
 
     def _buildDepartureFrame(self):
-        """Build the frame for the departure data."""        
+        """Build the frame for the departure data."""
         (frame, mainBox) = PIREPViewer.createFrame(xstr("pirepView_frame_departure"))
 
@@ -429,5 +429,5 @@
         dataBox = gtk.HBox()
         mainBox.pack_start(dataBox, False, False, 0)
-        
+
         self._departureRunway = \
             PIREPViewer.addLabeledData(dataBox,
@@ -441,7 +441,7 @@
 
         return frame
-                           
+
     def _buildArrivalFrame(self):
-        """Build the frame for the arrival data."""        
+        """Build the frame for the arrival data."""
         (frame, mainBox) = PIREPViewer.createFrame(xstr("pirepView_frame_arrival"))
 
@@ -457,5 +457,5 @@
         mainBox.pack_start(table, False, False, 0)
         table.set_row_spacings(4)
-        table.set_col_spacings(8)        
+        table.set_col_spacings(8)
 
         self._star = \
@@ -468,19 +468,19 @@
                                     xstr("pirepView_transition"),
                                     width = 12)
-                           
+
         self._approachType = \
             PIREPViewer.tableAttach(table, 0, 1,
                                     xstr("pirepView_approachType"),
                                     width = 7)
-                           
+
         self._arrivalRunway = \
-            PIREPViewer.tableAttach(table, 1, 1, 
+            PIREPViewer.tableAttach(table, 1, 1,
                                     xstr("pirepView_runway"),
                                     width = 5)
-                           
+
         return frame
 
     def _buildStatisticsFrame(self):
-        """Build the frame for the statistics data."""        
+        """Build the frame for the statistics data."""
         (frame, mainBox) = PIREPViewer.createFrame(xstr("pirepView_frame_statistics"))
 
@@ -490,10 +490,10 @@
         table.set_col_spacings(8)
         table.set_homogeneous(False)
-        
+
         self._blockTimeStart = \
             PIREPViewer.tableAttach(table, 0, 0,
                                     xstr("pirepView_blockTimeStart"),
                                     width = 6)
-        
+
         self._blockTimeEnd = \
             PIREPViewer.tableAttach(table, 1, 0,
@@ -505,7 +505,7 @@
                                     xstr("pirepView_flightTimeStart"),
                                     width = 6)
-        
+
         self._flightTimeEnd = \
-            PIREPViewer.tableAttach(table, 1, 1, 
+            PIREPViewer.tableAttach(table, 1, 1,
                                     xstr("pirepView_flightTimeEnd"),
                                     width = 6)
@@ -515,10 +515,10 @@
                                     xstr("pirepView_flownDistance"),
                                     width = 8)
-        
+
         self._fuelUsed = \
             PIREPViewer.tableAttach(table, 1, 2,
                                     xstr("pirepView_fuelUsed"),
                                     width = 6)
-        
+
         self._rating = \
             PIREPViewer.tableAttach(table, 0, 3,
@@ -528,5 +528,5 @@
 
     def _buildMiscellaneousFrame(self):
-        """Build the frame for the miscellaneous data."""        
+        """Build the frame for the miscellaneous data."""
         (frame, mainBox) = PIREPViewer.createFrame(xstr("pirepView_frame_miscellaneous"))
 
@@ -534,6 +534,6 @@
         mainBox.pack_start(table, False, False, 0)
         table.set_row_spacings(4)
-        table.set_col_spacings(8)        
-        
+        table.set_col_spacings(8)
+
         self._flownNumPassengers = \
             PIREPViewer.tableAttach(table, 0, 0,
@@ -565,5 +565,5 @@
                                     xstr("pirepView_flightType"),
                                     width = 15)
-            
+
         self._online = \
             PIREPViewer.tableAttach(table, 1, 2,
@@ -575,9 +575,9 @@
         mainBox.pack_start(PIREPViewer.getLabel(xstr("pirepView_delayCodes")),
                            False, False, 0)
-    
+
         (textWindow, self._delayCodes) = PIREPViewer.getTextWindow()
         mainBox.pack_start(textWindow, False, False, 0)
 
-        return frame        
+        return frame
 
     def _buildCommentsTab(self):
@@ -601,5 +601,5 @@
             PIREPViewer.getTextWindow(heightRequest = -1)
         flightDefectsBox.pack_start(flightDefectsWindow, True, True, 0)
-        
+
         return table
 
@@ -611,6 +611,6 @@
         addFaultTag(self._log.get_buffer())
         mainBox.pack_start(logWindow, True, True, 0)
-        
+
         return mainBox
-        
+
 #------------------------------------------------------------------------------