Index: src/mlx/gui/common.py
===================================================================
--- src/mlx/gui/common.py	(revision 84)
+++ src/mlx/gui/common.py	(revision 86)
@@ -85,4 +85,6 @@
         gtk.Entry.__init__(self)
 
+        self.set_alignment(1.0)
+
         self._defaultValue = defaultValue
         self._currentInteger = defaultValue
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 84)
+++ src/mlx/gui/flight.py	(revision 86)
@@ -686,5 +686,4 @@
         self._cargoWeight = IntegerEntry(defaultValue = 0)
         self._cargoWeight.set_width_chars(6)
-        self._cargoWeight.set_alignment(1.0)
         self._cargoWeight.connect("integer-changed", self._cargoWeightChanged)
         self._cargoWeight.set_tooltip_text("The weight of the cargo for your flight.")
@@ -1210,10 +1209,4 @@
             buffer.set_text(metar)
 
-    def finalize(self):
-        """Finalize the page."""
-        if not self._departure:
-            self._button.set_use_stock(True)
-            self._button.set_label(gtk.STOCK_GO_FORWARD)
-
     def _backClicked(self, button):
         """Called when the Back button is pressed."""
@@ -1225,4 +1218,6 @@
             if not self._finalized:
                 self._wizard.gui.startMonitoring()
+                self._button.set_use_stock(True)
+                self._button.set_label(gtk.STOCK_GO_FORWARD)
                 self._finalized = True
 
@@ -1278,5 +1273,5 @@
 
         self._v1 = IntegerEntry()
-        self._v1.set_width_chars(1)
+        self._v1.set_width_chars(4)
         self._v1.set_tooltip_markup("The takeoff decision speed in knots.")
         table.attach(self._v1, 2, 3, 2, 3)
@@ -1285,5 +1280,5 @@
         table.attach(gtk.Label("knots"), 3, 4, 2, 3)
         
-        label = gtk.Label("V<sub>_r</sub>:")
+        label = gtk.Label("V<sub>_R</sub>:")
         label.set_use_markup(True)
         label.set_use_underline(True)
@@ -1292,5 +1287,5 @@
 
         self._vr = IntegerEntry()
-        self._vr.set_width_chars(1)
+        self._vr.set_width_chars(4)
         self._vr.set_tooltip_markup("The takeoff rotation speed in knots.")
         table.attach(self._vr, 2, 3, 3, 4)
@@ -1306,5 +1301,5 @@
 
         self._v2 = IntegerEntry()
-        self._v2.set_width_chars(1)
+        self._v2.set_width_chars(4)
         self._v2.set_tooltip_markup("The takeoff safety speed in knots.")
         table.attach(self._v2, 2, 3, 4, 5)
@@ -1344,5 +1339,7 @@
         self._v1.set_int(None)
         self._v1.set_sensitive(True)
+        self._vr.set_int(None)
         self._vr.set_sensitive(True)
+        self._v2.set_int(None)
         self._v2.set_sensitive(True)
         self._button.set_sensitive(False)
@@ -1372,5 +1369,5 @@
         """Construct the landing page."""
         help = "Enter the STAR and/or transition, runway,\n" \
-               "approach type and V<sub>ref</sub> used."
+               "approach type and V<sub>Ref</sub> used."
 
         super(LandingPage, self).__init__(wizard, "Landing", help)
@@ -1379,5 +1376,5 @@
                                   xscale = 0.0, yscale = 0.0)
 
-        table = gtk.Table(5, 4)
+        table = gtk.Table(5, 5)
         table.set_row_spacings(4)
         table.set_col_spacings(16)
@@ -1400,5 +1397,5 @@
         self._star.connect("changed", self._updateForwardButton)
         self._star.set_sensitive(False)
-        table.attach(self._star, 2, 3, 0, 1)
+        table.attach(self._star, 2, 4, 0, 1)
         label.set_mnemonic_widget(self._starButton)
 
@@ -1417,5 +1414,5 @@
         self._transition.connect("changed", self._updateForwardButton)
         self._transition.set_sensitive(False)
-        table.attach(self._transition, 2, 3, 1, 2)
+        table.attach(self._transition, 2, 4, 1, 2)
         label.set_mnemonic_widget(self._transitionButton)
 
@@ -1429,5 +1426,5 @@
         self._runway.set_tooltip_text("The runway the landing is performed on.")
         self._runway.connect("changed", self._updateForwardButton)
-        table.attach(self._runway, 2, 3, 2, 3)
+        table.attach(self._runway, 2, 4, 2, 3)
         label.set_mnemonic_widget(self._runway)
 
@@ -1441,8 +1438,8 @@
         self._approachType.set_tooltip_text("The type of the approach, e.g. ILS or VISUAL.")
         self._approachType.connect("changed", self._updateForwardButton)
-        table.attach(self._approachType, 2, 3, 3, 4)
+        table.attach(self._approachType, 2, 4, 3, 4)
         label.set_mnemonic_widget(self._approachType)
 
-        label = gtk.Label("V<sub>_ref</sub>:")
+        label = gtk.Label("V<sub>_Ref</sub>:")
         label.set_use_markup(True)
         label.set_use_underline(True)
@@ -1450,14 +1447,12 @@
         table.attach(label, 1, 2, 5, 6)
 
-        self._vref = gtk.SpinButton()
-        self._vref.set_increments(step = 1, page = 10)
-        self._vref.set_range(min = 50, max = 300)
-        self._vref.set_value(140)
-        self._vref.set_numeric(True)
+        self._vref = IntegerEntry()
+        self._vref.set_width_chars(5)
         self._vref.set_tooltip_markup("The approach reference speed in knots.")
-        table.attach(self._vref, 2, 3, 5, 6)
+        self._vref.connect("integer-changed", self._vrefChanged)
+        table.attach(self._vref, 3, 4, 5, 6)
         label.set_mnemonic_widget(self._vref)
         
-        table.attach(gtk.Label("knots"), 3, 4, 5, 6)
+        table.attach(gtk.Label("knots"), 4, 5, 5, 6)
         
         button = self.addButton(gtk.STOCK_GO_BACK)
@@ -1472,4 +1467,9 @@
         self._starButton.set_active(True)
         self._transitionButton.set_active(True)
+
+    @property
+    def vref(self):
+        """Return the landing reference speed."""
+        return self._vref.get_int()
 
     def activate(self):
@@ -1489,5 +1489,5 @@
         self._approachType.set_sensitive(True)
 
-        self._vref.set_value(140)
+        self._vref.set_int(None)
         self._vref.set_sensitive(True)
 
@@ -1522,5 +1522,5 @@
         if active:
             self._transition.grab_focus()        
-        self._updateForwardButton()
+        self._updateForwardButton()    
 
     def _updateForwardButton(self, widget = None):
@@ -1533,6 +1533,11 @@
                      not self._transitionButton.get_active()) and \
                     self._runway.get_text()!="" and \
-                    self._approachType.get_text()!=""
+                    self._approachType.get_text()!="" and \
+                    self.vref is not None
         self._button.set_sensitive(sensitive)
+
+    def _vrefChanged(self, widget, value):
+        """Called when the Vref has changed."""
+        self._updateForwardButton()
 
     def _backClicked(self, button):
@@ -1571,5 +1576,6 @@
         self._takeoffPage = TakeoffPage(self) 
         self._pages.append(self._takeoffPage)
-        self._pages.append(LandingPage(self))
+        self._landingPage = LandingPage(self) 
+        self._pages.append(self._landingPage)
         
         maxWidth = 0
@@ -1629,15 +1635,20 @@
     def v1(self):
         """Get the V1 speed."""
-        return None if self._bookedFlight is None else self._takeoffPage.v1
+        return self._takeoffPage.v1
 
     @property
     def vr(self):
         """Get the Vr speed."""
-        return None if self._bookedFlight is None else self._takeoffPage.vr
+        return self._takeoffPage.vr
 
     @property
     def v2(self):
         """Get the V2 speed."""
-        return None if self._bookedFlight is None else self._takeoffPage.v2
+        return self._takeoffPage.v2
+
+    @property
+    def vref(self):
+        """Get the Vref speed."""
+        return self._landingPage.vref
 
     def nextPage(self, finalize = True):
Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 84)
+++ src/mlx/gui/gui.py	(revision 86)
@@ -133,4 +133,9 @@
         """Get the V2 speed calculated for the flight."""
         return self._wizard.v2
+        
+    @property
+    def vref(self):
+        """Get the Vref speed calculated for the flight."""
+        return self._wizard.vref
         
     def run(self):